package org.cl0zzzy.server;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import java.util.ArrayList;

@Root(name="catalog")
public class Catalog implements ParsableObject {
    private int CatalogTypeId;
    private int MediaResourceId;
    private ArrayList<CatalogItem> items = new ArrayList<CatalogItem>();

    public Catalog(int catalogTypeId, int mediaResourceId, ArrayList<CatalogItem> items) {
        CatalogTypeId = catalogTypeId;
        MediaResourceId = mediaResourceId;
        this.items = items;
    }

    @Attribute(name="CatalogTypeId")
    public int getCatalogTypeId() {
        return CatalogTypeId;
    }

    @Attribute(name="MediaResourceId")
    public int getMediaResourceId() {
        return MediaResourceId;
    }

    @ElementList(inline=true, name="item")
    public ArrayList<CatalogItem> getItems() {
        return items;
    }
}
