package org.cl0zzzy.server;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.Order;
import org.simpleframework.xml.Root;

@Root(name="user_avatar")
@Order(elements = {"Shape", "BodyParts", "Inventory", "Backgrounds", "Phones", "SportInventory"})
public class Inventory implements ParsableObject {
    private InventoryTab shape;
    private InventoryTab bodyparts;
    private InventoryTab inventory;
    private InventoryList backgrounds;
    private InventoryList phones;
    private InventoryList sportinv;

    public Inventory( InventoryTab shape, InventoryTab bodyparts, InventoryTab inventory, InventoryList backgrounds, InventoryList phones, InventoryList sportinv ) {
        this.shape = shape;
        this.bodyparts = bodyparts;
        this.inventory = inventory;
        this.backgrounds = backgrounds;
        this.phones = phones;
        this.sportinv = sportinv;
    }

    @Element(name="Shape")
    public InventoryTab getShape() {
        return this.shape;
    }

    @Element(name="BodyParts")
    public InventoryTab getBodyParts() {
        return this.bodyparts;
    }

    @Element(name="Inventory")
    public InventoryTab getInventory() {
        return this.inventory;
    }

    @Element(name="Backgrounds")
    public InventoryList getBackgrounds() {
        return this.backgrounds;
    }

    @Element(name="Phones")
    public InventoryList getPhones() {
        return this.phones;
    }

    @Element(name="SportInventory")
    public InventoryList getSportInventory() {
        return this.sportinv;
    }
}
