package org.cl0zzzy.server;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import java.util.ArrayList;

@Root(name="tab")
public class InventoryGroup implements ParsableObject {
    private int ID;
    private int TextResourceID;
    private int IsUsed;
    private int MediaResourceID;
    private int LayerID;

    private ArrayList<InventoryItem> items = new ArrayList<InventoryItem>();

    public InventoryGroup( int ID, int TextResourceID, int IsUsed, int MediaResourceID, int LayerID, ArrayList<InventoryItem> items ) {
        this.ID = ID;
        this.TextResourceID = TextResourceID;
        this.IsUsed = IsUsed;
        this.MediaResourceID = MediaResourceID;
        this.LayerID = LayerID;
        this.items = items;
    }

    @Attribute(name="ID")
    public int getID() {
        return ID;
    }

    @Attribute(name="TextResourceID")
    public int getTextResourceID() {
        return TextResourceID;
    }

    @Attribute(name="IsUsed")
    public int getIsUsed() {
        return IsUsed;
    }

    @Attribute(name="MediaResourceID")
    public int getMediaResourceID() {
        return MediaResourceID;
    }

    @Attribute(name="LayerID")
    public int getLayerID() {
        return LayerID;
    }

    @ElementList(inline = true, name="item")
    public ArrayList<InventoryItem> getItems() {
        return this.items;
    }
}