package org.cl0zzzy.server;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Root;

@Root(name="user")
public class UserInfo implements ParsableObject {
    private int UserId;
    private int RoleFlags;
    private int IsLimited;
    private int IsOnline;
    private int IsMinorSecretAgent;
    private int IsHomeLocked;
    private int IsClubLocked;
    private int IsClubPresent;
    private int ClubAccessType;
    private int IsFriend;
    private int Experience;
    private int Level;
    private int PositiveEnergy;
    private int MagicLevel;
    private int RaceLevel;
    private int PhoneID;
    private int BackgroundID;
    private int CampId;
    private int NiftTotalCount;
    private String LocationServerName;
    private String DateRegistered;
    private int InstructorLevel;
    private int UsualTickets;
    private int MagicTickets;
    private int VisaId;
    private int CurrentUseCount;
    private int LastNewspaperId;
    private int HasSnFriends;
    private int MinsLeft;
    private int TimesUsed;
    private String Name;

    public UserInfo(int userId,
                    int roleFlags,
                    int isLimited,
                    int isOnline,
                    int isMinorSecretAgent,
                    int isHomeLocked,
                    int isClubLocked,
                    int isClubPresent,
                    int clubAccessType,
                    int isFriend,
                    int experience,
                    int level,
                    int positiveEnergy,
                    int magicLevel,
                    int raceLevel,
                    int phoneID,
                    int backgroundID,
                    int campId,
                    int niftTotalCount,
                    String locationServerName,
                    String dateRegistered,
                    int instructorLevel,
                    int usualTickets,
                    int magicTickets,
                    int visaId,
                    int currentUseCount,
                    int lastNewspaperId,
                    int hasSnFriends,
                    int minsLeft,
                    int timesUsed,
                    String name ) {
        UserId = userId;
        RoleFlags = roleFlags;
        IsLimited = isLimited;
        IsOnline = isOnline;
        IsMinorSecretAgent = isMinorSecretAgent;
        IsHomeLocked = isHomeLocked;
        IsClubLocked = isClubLocked;
        IsClubPresent = isClubPresent;
        ClubAccessType = clubAccessType;
        IsFriend = isFriend;
        Experience = experience;
        Level = level;
        PositiveEnergy = positiveEnergy;
        MagicLevel = magicLevel;
        RaceLevel = raceLevel;
        PhoneID = phoneID;
        BackgroundID = backgroundID;
        CampId = campId;
        NiftTotalCount = niftTotalCount;
        LocationServerName = locationServerName;
        DateRegistered = dateRegistered;
        InstructorLevel = instructorLevel;
        UsualTickets = usualTickets;
        MagicTickets = magicTickets;
        VisaId = visaId;
        CurrentUseCount = currentUseCount;
        LastNewspaperId = lastNewspaperId;
        HasSnFriends = hasSnFriends;
        MinsLeft = minsLeft;
        TimesUsed = timesUsed;
        Name = name;
    }

    @Attribute(name="Name")
    public String getName() {
        return Name;
    }

    @Attribute(name="UserId")
    public int getUserId() {
        return UserId;
    }

    @Attribute(name="RoleFlags")
    public int getRoleFlags() {
        return RoleFlags;
    }

    @Attribute(name="IsLimited")
    public int getIsLimited() {
        return IsLimited;
    }

    @Attribute(name="IsOnline")
    public int getIsOnline() {
        return IsOnline;
    }

    @Attribute(name="IsMinorSecretAgent")
    public int getIsMinorSecretAgent() {
        return IsMinorSecretAgent;
    }

    @Attribute(name="IsHomeLocked")
    public int getIsHomeLocked() {
        return IsHomeLocked;
    }

    @Attribute(name="IsClubLocked")
    public int getIsClubLocked() {
        return IsClubLocked;
    }

    @Attribute(name="IsClubPresent")
    public int getIsClubPresent() {
        return IsClubPresent;
    }

    @Attribute(name="ClubAccessType")
    public int getClubAccessType() {
        return ClubAccessType;
    }

    @Attribute(name="IsFriend")
    public int getIsFriend() {
        return IsFriend;
    }

    @Attribute(name="Experience")
    public int getExperience() {
        return Experience;
    }

    @Attribute(name="Level")
    public int getLevel() {
        return Level;
    }

    @Attribute(name="PositiveEnergy")
    public int getPositiveEnergy() {
        return PositiveEnergy;
    }

    @Attribute(name="MagicLevel")
    public int getMagicLevel() {
        return MagicLevel;
    }

    @Attribute(name="RaceLevel")
    public int getRaceLevel() {
        return RaceLevel;
    }

    @Attribute(name="PhoneID")
    public int getPhoneID() {
        return PhoneID;
    }

    @Attribute(name="BackgroundID")
    public int getBackgroundID() {
        return BackgroundID;
    }

    @Attribute(name="CampId")
    public int getCampId() {
        return CampId;
    }

    @Attribute(name="NiftTotalCount")
    public int getNiftTotalCount() {
        return NiftTotalCount;
    }

    @Attribute(name="LocationServerName")
    public String getLocationServerName() {
        return LocationServerName;
    }

    @Attribute(name="DateRegistered")
    public String getDateRegistered() {
        return DateRegistered;
    }

    @Attribute(name="InstructorLevel")
    public int getInstructorLevel() {
        return InstructorLevel;
    }

    @Attribute(name="UsualTickets")
    public int getUsualTickets() {
        return UsualTickets;
    }

    @Attribute(name="MagicTickets")
    public int getMagicTickets() {
        return MagicTickets;
    }

    @Attribute(name="VisaId")
    public int getVisaId() {
        return VisaId;
    }

    @Attribute(name="CurrentUseCount")
    public int getCurrentUseCount() {
        return CurrentUseCount;
    }

    @Attribute(name="LastNewspaperId")
    public int getLastNewspaperId() {
        return LastNewspaperId;
    }

    @Attribute(name="HasSnFriends")
    public int getHasSnFriends() {
        return HasSnFriends;
    }

    @Attribute(name="MinsLeft")
    public int getMinsLeft() {
        return MinsLeft;
    }

    @Attribute(name="TimesUsed")
    public int getTimesUsed() {
        return TimesUsed;
    }
}
