package org.cl0zzzy.server;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;
import java.util.ArrayList;

@Root(name="response")
public class UserInitInfo implements ParsableObject {
    private UserMagicAbilities magicAbilities;
    private UserAccount userAccount;
    private UserInfo userInfo;
    private UserPhone userPhone;
    private ArrayList<InventoryItem> avatar;

    @Element(name="user_magic_abilities")
    public UserMagicAbilities getMagicAbilities() {
        return magicAbilities;
    }

    @Element(name="account")
    public UserAccount getUserAccount() {
        return userAccount;
    }

    @Element(name="user")
    public UserInfo getUserInfo() {
        return userInfo;
    }

    @Element(name="user_phone")
    public UserPhone getUserPhone() {
        return userPhone;
    }

    @ElementList(inline = true, name="avatar")
    public ArrayList<InventoryItem> getAvatar() {
        return this.avatar;
    }

    public UserInitInfo(UserMagicAbilities magicAbilities, UserAccount userAccount, UserInfo userInfo, UserPhone userPhone, ArrayList<InventoryItem> avatar) {
        this.magicAbilities = magicAbilities;
        this.userAccount = userAccount;
        this.userInfo = userInfo;
        this.userPhone = userPhone;
        this.avatar = avatar;
    }
}
