package org.cl0zzzy.sqlite;

import java.security.MessageDigest;
import java.sql.*;
import java.util.ArrayList;

import org.cl0zzzy.rtmp.AMFObject;
import org.cl0zzzy.rtmp.AMFObjectArray;
import org.cl0zzzy.rtmp.Util;
import org.cl0zzzy.server.*;

public class DB {
	public static final String URL = "jdbc:sqlite:data.sqlite";
	public static Connection connection;
	
	public static void connect() {
		try {
			connection = DriverManager.getConnection(URL);
			System.out.println("SQLITE daemon started");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public static ResultSet execute( String sql ) {
		try {
			return connection.createStatement().executeQuery(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static void executeUpdate( String sql ) {
		try {
			connection.createStatement().executeUpdate(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static String getSecureCode() {
		try {
			ResultSet rs = execute( "SELECT CODE FROM secure WHERE ID = '1'" );
			String resp = "";
			while( rs.next() ) {
				resp = rs.getString("CODE");
			}
			return resp;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static void insertAccount( String username, String pwd ) {
		try {
			executeUpdate("INSERT INTO users(Username, Password, RoleFlags, InstructorLevel, MagicLevel, RaceLevel, PhoneID, BackgroundID, UsualTickets, MagicTickets, Experience, Level, PositiveEnergy, VisaId, CurrentUseCount, LastNewspaperId, IsClubPresent, IsMinorSecretAgent, HasSnFriends, CampId, MinsLeft, TimesUsed) VALUES ('"+username+"', '"+Util.MD5(pwd)+"', '2', '10', '10', '10', '2', '10', '100', '100', '1000', '120', '100', '1', '1', '10', '0', '1', '1', '1', '1', '1')");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static Account getUserAccountByName( String name ) {
		try {
			ResultSet rs = execute( "SELECT ID, Password, RoleFlags FROM users WHERE Username = '" + name + "';" );
			Account resp = null;
			while( rs.next() ) {
				resp = new Account(rs.getInt("ID"), name, rs.getString("Password"));
			}
			return resp;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getPreloaders() {
		try {
			ResultSet result = execute( "SELECT * FROM preloaders WHERE isSelected = 1" );
			String resp = "";
			while( result.next() ) {
				resp = resp + "<i MRId=\"" + result.getString("MRId") + "\" ShowTime=\"" + result.getString("ShowTime") + "\" />";
			}
			return resp;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getPromotions() {
		try {
			ResultSet result = execute( "SELECT * FROM promotions WHERE isSelected = 1" );
			String resp = "";
			while( result.next() ) {
				resp = resp + "<i MRId=\"" + result.getString("MRId") + "\" State=\"" + result.getString("State") + "\" />";
			}
			return resp;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}

	public static String getPromotionBanners() {
		try {
			ResultSet result = execute( "SELECT * FROM promotion_banners WHERE isSelected = 1" );
			String resp = "";
			while( result.next() ) {
				resp = resp + "<i MRId=\"" + result.getString("MRId") + "\" />";
			}
			return resp;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getPlayerName( int UID ) {
		try {
			ResultSet result = execute( "SELECT Username FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getString("Username");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static int getPlayerRoleFlags( int UID ) {
		try {
			ResultSet result = execute( "SELECT RoleFlags FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("RoleFlags");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}

	public static int getPlayerInstructorLevel( int UID ) {
		try {
			ResultSet result = execute( "SELECT InstructorLevel FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("InstructorLevel");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerMagicLevel( int UID ) {
		try {
			ResultSet result = execute( "SELECT MagicLevel FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("MagicLevel");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerRaceLevel( int UID ) {
		try {
			ResultSet result = execute( "SELECT RaceLevel FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("RaceLevel");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerPhoneID( int UID ) {
		try {
			ResultSet result = execute( "SELECT PhoneID FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("PhoneID");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerBackgroundID( int UID ) {
		try {
			ResultSet result = execute( "SELECT BackgroundID FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("BackgroundID");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerUsualTickets( int UID ) {
		try {
			ResultSet result = execute( "SELECT UsualTickets FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("UsualTickets");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerMagicTickets( int UID ) {
		try {
			ResultSet result = execute( "SELECT MagicTickets FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("MagicTickets");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerExperience( int UID ) {
		try {
			ResultSet result = execute( "SELECT Experience FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("Experience");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerLevel( int UID ) {
		try {
			ResultSet result = execute( "SELECT Level FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("Level");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 1;
	}
	
	public static int getPlayerPositiveEnergy( int UID ) {
		try {
			ResultSet result = execute( "SELECT PositiveEnergy FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("PositiveEnergy");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerVisaId( int UID ) {
		try {
			ResultSet result = execute( "SELECT VisaId FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("VisaId");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerCurrentUseCount( int UID ) {
		try {
			ResultSet result = execute( "SELECT CurrentUseCount FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("CurrentUseCount");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerLastNewspaperId( int UID ) {
		try {
			ResultSet result = execute( "SELECT LastNewspaperId FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("LastNewspaperId");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerIsClubPresent( int UID ) {
		try {
			ResultSet result = execute( "SELECT IsClubPresent FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("IsClubPresent");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerIsClubLocked( int UID ) {
		/*try {
			ResultSet result = execute( "SELECT isClubLocked FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getString("isClubLocked");
		} catch ( Exception e ) {
			e.printStackTrace();
		}*/
		return 1;
	}
	
	public static int getPlayerIsMinorSecretAgent( int UID ) {
		try {
			ResultSet result = execute( "SELECT IsMinorSecretAgent FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("IsMinorSecretAgent");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerHasSnFriends( int UID ) {
		try {
			ResultSet result = execute( "SELECT HasSnFriends FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("HasSnFriends");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static String getPlayerCampId( int UID ) {
		try {
			ResultSet result = execute( "SELECT CampId FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getString("CampId");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static int getPlayerMinsLeft( int UID ) {
		try {
			ResultSet result = execute( "SELECT MinsLeft FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("MinsLeft");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getPlayerTimesUsed( int UID ) {
		try {
			ResultSet result = execute( "SELECT TimesUsed FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("TimesUsed");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static int getRoleFlags( int UID ) {
		try {
			ResultSet result = execute( "SELECT RoleFlags FROM users WHERE ID = '"+UID+"'" );
			result.next();
			return result.getInt("RoleFlags");
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static String getToken( int UID ) {
		try {
			ResultSet result = execute( "SELECT CODE FROM secure WHERE ID = '1'" );
			result.next();
			return md5( result.getString("CODE") + UID );
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getLocationObjects( int locationId ) {
		try {
			ResultSet result = execute( "SELECT * FROM objects WHERE LocationId = '"+locationId+"'" );
			String objects = "";
			while( result.next() ) {
				objects = objects + "<object ID=\""+result.getString("ID")+"\" AObjectTypeId=\""+result.getString("AObjectTypeId")+"\" AObjectId=\""+result.getString("AObjectId")+"\" AObjectRefId=\""+result.getString("AObjectRefId")+"\" MediaResourceID=\""+result.getString("MediaResourceID")+"\" x=\""+result.getString("x")+"\" y=\""+result.getString("y")+"\">"+result.getString("options")+"</object>";
			}
			return objects;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "<object/>";
	}
	
	public static String getGameXML( String GID ) {
		try {
			ResultSet result = execute( "SELECT * FROM games WHERE ID = '" + GID + "'" );
			result.next();
			return "<item ID=\""+result.getString("ID")+"\" GameName=\""+result.getString("GameName")+"\" NameTRId=\""+result.getString("NameTRId")+"\" TextResourceID=\""+result.getString("TextResourceID")+"\" MediaResourceID=\""+result.getString("MediaResourceID")+"\" ScoreDivisor=\""+result.getString("ScoreDivisor")+"\" AvatarType=\""+result.getString("AvatarType")+"\" IsPromptUsed=\""+result.getString("IsPromptUsed")+"\" IsFullscreen=\""+result.getString("IsFullscreen")+"\" IsShowPoints=\""+result.getString("IsShowPoints")+"\" StartFullTime=\""+result.getString("StartFullTime")+"\" StartLackTime=\""+result.getString("StartLackTime")+"\" Options=\""+result.getString("Options")+"\" Token=\""+result.getString("Token")+"\">"+result.getString("Groups")+"</item>";
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "</game>";
	}
	
	public static String getLocationXML( int locationId ) {
		try {
			String objects = getLocationObjects(locationId);
			ResultSet result = execute( "SELECT * FROM locations WHERE ID = '"+locationId+"'" );
			result.next();
			System.out.println("!!!ASD = " + locationId);
			return "<location ID=\""+result.getString("ID")+"\" IsHome=\""+result.getString("IsHome")+"\" IsClub=\""+result.getString("IsClub")+"\" IsLocked=\""+result.getString("IsLocked")+"\" IsVisaAccessPermitted=\""+result.getString("IsVisaAccessPermitted")+"\" MediaResourceID=\""+result.getString("MediaResourceID")+"\" x=\""+result.getString("x")+"\" y=\""+result.getString("y")+"\" Name=\""+result.getString("Name")+"\">"+objects+"</location>";
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "<location/>";
	}
	
	public static int getLocationId( int locationId ) {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE ID = '"+locationId+"'" );
			result.next();
			return result.getInt("ID");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static String getLocationX( int locationId ) {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE ID = '"+locationId+"'" );
			result.next();
			return result.getString("x");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getDefaultLocationX() {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE isDefault = '1'" );
			result.next();
			return result.getString("x");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getLocationY( int locationId ) {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE ID = '"+locationId+"'" );
			result.next();
			return result.getString("y");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static String getDefaultLocationY() {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE isDefault = '1'" );
			result.next();
			return result.getString("y");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
	
	public static int getDefaultLocationId() {
		try {
			ResultSet result = execute( "SELECT * FROM locations WHERE isDefault = '1'" );
			result.next();
			return result.getInt("ID");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public static String getDefaultLocationXML() {
		return getLocationXML( getDefaultLocationId() );
	}

	/*public static String getGoodsFromInventory( int UID, String goodTypeId ) {
		try {
			ResultSet result = execute( "SELECT a.GoodId, g.GoodTypeId, g.MRId, g.TRId, g.PublishDate FROM avatarinventory as a, goods as g WHERE UserId = '"+UID+"' AND g.Id = a.GoodId AND g.GoodTypeId = '"+goodTypeId+"'" );
			String str = "";
			while( result.next() ) {
				str = str + "<item ID=\""+result.getString("GoodId")+"\" IsLimited=\"0\" GoodID=\""+result.getString("GoodId")+"\" IsUsed=\"0\" Date=\""+result.getString("PublishDate")+"\" MediaResourceID=\""+result.getString("MRId")+"\" TextResourceID=\""+result.getString("TRId")+"\" Pollution=\"0\"/>";
			}
			return str;
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}*/

	public static ArrayList<InventoryItem> getGoodsFromInventory( int UID, String goodTypeId ) {
		try {
			ResultSet result = execute( "SELECT a.GoodId, g.GoodTypeId, g.MRId, g.TRId, g.PublishDate FROM avatarinventory as a, goods as g WHERE UserId = '"+UID+"' AND g.Id = a.GoodId AND g.GoodTypeId = '"+goodTypeId+"'" );
			ArrayList<InventoryItem> items = new ArrayList<InventoryItem>();
			while( result.next() ) {
				items.add(new InventoryItem(result.getInt("GoodId"), 0, 0, result.getString("PublishDate"), result.getInt("MRId"), result.getInt("TRId"), 0, 0, 0, 0, 0));
			}
			return items;
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return new ArrayList<InventoryItem>();
	}
	
	public static String sendPostcard( int UID, int recieverId, String cardId ) {
		String pcid = "";
		try {
			executeUpdate("INSERT INTO postcards (senderId, recieverId, cardId, isNew) VALUES ('"+UID+"', '"+recieverId+"', '"+cardId+"', '1')");
			ResultSet result = execute( "SELECT LAST_INSERT_ID() as ID FROM postcards" );
			result.next();
			pcid = result.getString("ID");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return pcid;
	}
	
	public static void removePostcard( String MSGID ) {
		try {
			executeUpdate("DELETE FROM postcards WHERE ID = '"+MSGID+"'");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static void markPostcardAsRead( String MSGID ) {
		try {
			executeUpdate("UPDATE postcards SET isNew='0' WHERE ID = '"+MSGID+"'");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static void markMessageAsRead( String MSGID ) {
		try {
			executeUpdate("UPDATE messages SET isNew='0' WHERE ID = '"+MSGID+"'");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static String getPostcards( int UID ) {
		String xml = "";
		try {
			ResultSet result = execute("SELECT postcards.ID as ID, senderId, recieverId, cardId, isNew, users.Username as Username FROM postcards, users WHERE recieverId = '"+UID+"' and senderId = users.ID");
			while( result.next() ) {
				xml = xml + "<item Id=\""+result.getString("ID")+"\" DateSent=\"\" SenderId=\""+result.getString("senderId")+"\" SenderName=\""+result.getString("Username")+"\" CardId=\""+result.getString("cardId")+"\" IsNew=\""+result.getString("IsNew")+"\" />";
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return xml;
	}
	
	public static String getPhoneMessages( int UID ) {
		String xml = "";
		try {
			ResultSet result = execute("SELECT messages.ID as ID, senderId, recieverId, text, isNew, users.Username as Username FROM messages, users WHERE recieverId = '"+UID+"' and senderId = users.ID");
			while( result.next() ) {
				xml = xml + "<item Id=\""+result.getString("ID")+"\" DateSent=\"\" SenderId=\""+result.getString("senderId")+"\" SenderName=\""+result.getString("Username")+"\" Text=\""+result.getString("text")+"\" IsNew=\""+result.getString("IsNew")+"\" />";
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return xml;
	}
	
	public static String sendPhoneMessage( int UID, int recieverId, String message ) {
		String msgId = "";
		try {
			executeUpdate("INSERT INTO messages (senderId, recieverId, text, isNew) VALUES ('"+UID+"', '"+recieverId+"', '"+message+"', '1')");
			ResultSet result = execute( "SELECT LAST_INSERT_ID() as ID FROM messages" );
			result.next();
			msgId = result.getString("ID");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return msgId;
	}
	
	public static ArrayList<UData> getUserDataArray( int UID ) {
		try {
			ArrayList<UData> ids = new ArrayList<UData>();
			ResultSet result = execute( "SELECT * FROM userdata WHERE UserId='"+UID+"'" );
			while( result.next() ) {
				UData index = new UData();
				if( result.getString("IsBodyPart").equals("0") ) {
					index.isBodyPart = false;
					index.id = result.getString("GoodId");
				} else {
					index.isBodyPart = true;
					index.id = result.getString("BodyPartId");
					index.color = result.getString("Color");
				}
				ids.add(index);
			}
			return ids;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return new ArrayList<UData>();
	}
	
	public static void addFriend( int UID, int request ) {
		try {
			executeUpdate("UPDATE friends SET state='2' WHERE senderId = '"+request+"' AND recieverId = '"+UID+"'");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static void removeFriend( int UID, int friend ) {
		try {
			executeUpdate("DELETE FROM friends WHERE ( senderId = '"+UID+"' AND recieverId = '"+friend+"' ) OR ( senderId = '"+friend+"' AND recieverId = '"+UID+"' )");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static AMFObjectArray getUserFriendsRequests( int UID, ArrayList<Player> playersArray ) {
		AMFObjectArray array = new AMFObjectArray();
		try {
			ResultSet result = execute("SELECT * FROM friends WHERE recieverId = '"+UID+"' AND state = '1'");
			int pos = 1;
			while( result.next() ) {
				String id = "";
				if( result.getInt("recieverId") == UID ) {
					id = result.getString("senderId");
				} else {
					id = result.getString("recieverId");
				}
				AMFObjectArray player = new AMFObjectArray();
				boolean is = false;
				for( int i = 0; i < playersArray.size(); i++ ) {
					if( playersArray.get(i).getId() == Integer.parseInt(id) ) {
						is = true;
						break;
					}
				}
				if( is ) {
					player.add("IsOnline", new AMFObject( AMFObject.AMF_STRING, "1" ) );
				} else {
					player.add("IsOnline", new AMFObject( AMFObject.AMF_STRING, "0" ) );
				}
				ResultSet uname = execute( "SELECT Username FROM users WHERE ID = '"+id+"'" );
				uname.next();
				player.add("UserName", new AMFObject( AMFObject.AMF_STRING, uname.getString("Username") ));
				player.add("UserId", new AMFObject( AMFObject.AMF_STRING, id ));
				player.add("SnName", new AMFObject( AMFObject.AMF_STRING, "" ));
				array.add(String.valueOf(pos), new AMFObject( AMFObject.AMF_OBJECT_START, player ));
				pos++;
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return array;
	}

	public static AMFObjectArray getUserFriends( int UID, ArrayList<Player> playersArray ) {
		AMFObjectArray array = new AMFObjectArray();
		try {
			ResultSet result = execute("SELECT * FROM friends WHERE (recieverId = '"+UID+"' or senderId = '"+UID+"') AND state = '2'");
			int pos = 1;
			while( result.next() ) {
				int id = 0;
				if( result.getInt("recieverId") == UID ) {
					id = result.getInt("senderId");
				} else {
					id = result.getInt("recieverId");
				}
				AMFObjectArray player = new AMFObjectArray();
				boolean is = false;
				for( int i = 0; i < playersArray.size(); i++ ) {
					if( playersArray.get(i).getId() == id ) {
						is = true;
						break;
					}
				}
				if( is ) {
					player.add("IsOnline", new AMFObject( AMFObject.AMF_STRING, "1" ) );
				} else {
					player.add("IsOnline", new AMFObject( AMFObject.AMF_STRING, "0" ) );
				}
				ResultSet uname = execute( "SELECT Username FROM users WHERE ID = '"+id+"'" );
				uname.next();
				player.add("UserName", new AMFObject( AMFObject.AMF_STRING, uname.getString("Username") ));
				player.add("UserId", new AMFObject( AMFObject.AMF_STRING, id ));
				player.add("SnName", new AMFObject( AMFObject.AMF_STRING, "" ));
				array.add(String.valueOf(pos), new AMFObject( AMFObject.AMF_OBJECT_START, player ));
				pos++;
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return array;
	}

	public static int getIsHomeLocked( int id ) {
		try {
			ResultSet rs = execute("SELECT IsLocked FROM home WHERE UserId = '"+id+"'");
			if( rs.next() ) {
				return rs.getInt("IsLocked");
			}
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 1;
	}

	public static UserAccount getUserAccount( int id ) {
		try {
			ResultSet rs = execute("SELECT Balance FROM users WHERE ID = '"+id+"'");
			return new UserAccount(rs.getInt("Balance"), 3253, 2221);
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}

	public static UserPhone getUserPhone( int id ) {
		try {
			ResultSet rs = execute("SELECT PhoneSkin, PhoneID, Balance FROM users WHERE ID = '"+id+"'");
			int balance = rs.getInt("Balance");
			int pid = rs.getInt("PhoneID");
			return new UserPhone(999, rs.getInt("PhoneSkin"), pid, balance);
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}

	public static UserInfo getUserInfo( int id, int isFriend ) {
		try {
			UserInfo ui = new UserInfo(id,
					DB.getPlayerRoleFlags(id),
					0,
					1,
					DB.getPlayerIsMinorSecretAgent(id),
					DB.getIsHomeLocked(id),
					DB.getPlayerIsClubLocked(id),
					DB.getPlayerIsClubPresent(id),
					0,
					isFriend,
					DB.getPlayerExperience(id),
					DB.getPlayerLevel(id),
					100,
					DB.getPlayerMagicLevel(id),
					0,
					DB.getPlayerPhoneID(id),
					DB.getPlayerBackgroundID(id),
					0,
					0,
					"Неофициальный сервер",
					"2008-08-08T12:07:44.927",
					DB.getPlayerInstructorLevel(id),
					DB.getPlayerUsualTickets(id),
					DB.getPlayerMagicTickets(id),
					DB.getPlayerVisaId(id),
					DB.getPlayerCurrentUseCount(id),
					DB.getPlayerLastNewspaperId(id),
					DB.getPlayerHasSnFriends(id),
					DB.getPlayerMinsLeft(id),
					DB.getPlayerTimesUsed(id),
					DB.getPlayerName(id));
			return ui;
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}

	public static void requestFriend( int senderId, int recieverId ) {
		try {
			ResultSet result = execute("SELECT * FROM friends WHERE (senderId = '"+senderId+"' AND recieverId = '"+recieverId+"') OR (senderId = '"+recieverId+"' AND recieverId = '"+senderId+"')");
			if( !result.next() ) {
				result.close();
				executeUpdate("INSERT INTO friends (senderId, recieverId, state) VALUES ('"+senderId+"', '"+recieverId+"', '1')");
			} else {
				if( result.getInt("senderId") == recieverId ) {
					addFriend( senderId, recieverId );
				}
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}

	public static void clearMagicAbilities( int UID ) {
		try {
			executeUpdate( "DELETE FROM mainventory WHERE UserId = '"+UID+"' AND isexp = 'true' AND exp < ( datetime('now', ('-' || expdays || ' days')) )" );
		} catch ( Exception e ) {
			e.printStackTrace();
		}
	}

	public static UserMagicAbilities getUserMagicAbilities( int UID ) {
		ArrayList<MagicAbility> ma = new ArrayList<MagicAbility>();
		try {
			ResultSet result = execute( "SELECT MagicAbilityId FROM mainventory WHERE UserId = '"+UID+"'" );
			while( result.next() ) {
				ma.add(new MagicAbility(result.getInt("MagicAbilityId"), "2020-04-28T19:50:31.107", 0));
			}
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return new UserMagicAbilities(ma);
	}

	public static void addMagicAbility( int UID, String MAID, String expdays, String isexp ) {
		try {
			executeUpdate("INSERT INTO mainventory (UserId, MagicAbilityId, exp, expdays, isexp) VALUES ('" + UID + "', '" + MAID + "', date('now'), '" + expdays + "', '" + isexp + "')");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static String calcLayer( String bpid ) {
		if( bpid.equals("56") || bpid.equals("60") || bpid.equals("64") ||
				bpid.equals("69") || bpid.equals("73") || bpid.equals("77") || bpid.equals("83") || bpid.equals("89") ) {
			return "20";
		} else if( bpid.equals("55") || bpid.equals("62") || bpid.equals("66") ||
				bpid.equals("71") || bpid.equals("75") || bpid.equals("80") || bpid.equals("86") ||
				bpid.equals("92")) {
			return "10";
		} else if( bpid.equals("78") || bpid.equals("84") || bpid.equals("90") || bpid.equals("95") ||
				bpid.equals("96") || bpid.equals("97") ) {
			return "50";
		} else if( bpid.equals("59") || bpid.equals("61") || bpid.equals("65") || bpid.equals("70") ||
				bpid.equals("74") || bpid.equals("79") || bpid.equals("85") || bpid.equals("91") ) {
			return "30";
		} else if( bpid.equals("58") || bpid.equals("68") || bpid.equals("82") || bpid.equals("88") ||
				bpid.equals("94") ) {
			return "40";
		} else if( bpid.equals("57") || bpid.equals("67") || bpid.equals("81") || bpid.equals("87") ||
				bpid.equals("93") ) {
			return "26";
		} else if( bpid.equals("63") || bpid.equals("72") || bpid.equals("76") ) {
			return "41";
		} else if( bpid.equals("99") || bpid.equals("100") ||  bpid.equals("101") ||  bpid.equals("102") ||
				 bpid.equals("103") ) {
			return "55";
		}
		return "0";
	}

	private static String calcTypeId( String bpid ) {
		if( bpid.equals("56") || bpid.equals("60") || bpid.equals("64") ||
				bpid.equals("69") || bpid.equals("73") || bpid.equals("77") || bpid.equals("83") || bpid.equals("89") ) {
			return "3";
		} else if( bpid.equals("55") || bpid.equals("62") || bpid.equals("66") ||
				bpid.equals("71") || bpid.equals("75") || bpid.equals("80") || bpid.equals("86") ||
				bpid.equals("92")) {
			return "2";
		} else if( bpid.equals("78") || bpid.equals("84") || bpid.equals("90") || bpid.equals("95") ||
				bpid.equals("96") || bpid.equals("97") ) {
			return "8";
		} else if( bpid.equals("59") || bpid.equals("61") || bpid.equals("65") || bpid.equals("70") ||
				bpid.equals("74") || bpid.equals("79") || bpid.equals("85") || bpid.equals("91") ) {
			return "7";
		} else if( bpid.equals("58") || bpid.equals("68") || bpid.equals("82") || bpid.equals("88") ||
				bpid.equals("94") ) {
			return "6";
		} else if( bpid.equals("57") || bpid.equals("67") || bpid.equals("81") || bpid.equals("87") ||
				bpid.equals("93") ) {
			return "5";
		} else if( bpid.equals("63") || bpid.equals("72") || bpid.equals("76") ) {
			return "11";
		} else if( bpid.equals("99") || bpid.equals("100") ||  bpid.equals("101") ||  bpid.equals("102") ||
				 bpid.equals("103") ) {
			return "12";
		}
		return "1";
	}

	public static void insertUserdata( int UID, String id, String IsBodyPart, String BodyPartId, String Color, String GoodID ) {
		try {
			executeUpdate( "INSERT INTO userdata (UserId, Id, IsBodyPart, BodyPartId, Color, GoodID) VALUES ('"+UID+"', '"+id+"', '"+IsBodyPart+"', '"+BodyPartId+"', '"+Color+"', '"+GoodID+"')" );
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}

	public static void updateMoney( int UID, int usual, int magic ) {
		try {
			executeUpdate( "UPDATE users SET UsualTickets = '"+usual+"', MagicTickets = '"+magic+"' WHERE ID = '"+UID+"'" );
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}

	public static void clearUserdata( int UID ) {
		try {
			executeUpdate( "DELETE FROM userdata WHERE UserId = '"+UID+"'" );
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}

	public static AMFObjectArray getUserData( int UID ) {
		try {
			ResultSet result = execute( "SELECT * FROM userdata WHERE UserId = '"+UID+"'" );
			AMFObjectArray body = new AMFObjectArray();
			int i = 1;
			while( result.next() ) {
				AMFObjectArray item = new AMFObjectArray();
				item.add("BodyPartTypeId", new AMFObject( AMFObject.AMF_STRING, calcTypeId( result.getString("BodyPartId") ) ));
				if( !result.getString("Color").equals("-1") ) {
					item.add("Color", new AMFObject( AMFObject.AMF_STRING, result.getString("Color") ));
				}
				item.add("Id", new AMFObject( AMFObject.AMF_STRING, result.getString("Id") ));
				item.add("IsBodyPart", new AMFObject( AMFObject.AMF_STRING, result.getString("IsBodyPart") ));
				item.add("BodyPartId", new AMFObject( AMFObject.AMF_STRING, result.getString("BodyPartId") ));
				item.add("GoodID", new AMFObject( AMFObject.AMF_STRING, result.getString("GoodID") ));
				int goodId = result.getInt("GoodID");
				if( result.getString("IsBodyPart").equals("1") ) {
					item.add("MediaResourceID", new AMFObject( AMFObject.AMF_STRING, result.getString("BodyPartId") ));
					item.add("LayerID", new AMFObject( AMFObject.AMF_STRING, calcLayer( result.getString("BodyPartId") ) ));
				} else {
					item.add("MediaResourceID", new AMFObject( AMFObject.AMF_STRING, getGoodById(goodId).getMediaResourceID() ));
					item.add("LayerID", new AMFObject( AMFObject.AMF_STRING, getGoodById(goodId).getLayerID() ));
					item.add("GoodTypeID", new AMFObject( AMFObject.AMF_STRING, getGoodById(goodId).getGoodTypeId() ));
				}
				body.add(String.valueOf(i), new AMFObject( AMFObject.AMF_OBJECT_START, item ));
				i++;
			}
			return body;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return new AMFObjectArray();
	}

	public static int getIsUsedGood( int id, InventoryItem item ) {
		try {
			ResultSet result = execute("SELECT 1 AS IsUsed FROM userdata WHERE userdata.UserId = '"+id+"' AND userdata.Id = '"+item.getID()+"'");
			if( result.next() ) return 1;
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}

	public static int getBodyPartColor( int id, InventoryItem item ) {
		try {
			ResultSet result = execute("SELECT Color FROM userdata WHERE userdata.UserId = '"+id+"' AND userdata.Id = '"+item.getID()+"'");
			if( result.next() ) return result.getInt("Color");
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return 0;
	}

	public static ArrayList<InventoryItem> getUserAvatar( int id ) {
		try {
			ResultSet result = execute( "SELECT a.Id, g.GoodTypeId, g.MRId, g.TRId, g.PublishDate, a.IsBodyPart, a.Color FROM userdata as a, goods as g WHERE a.UserId = '"+id+"' AND g.Id = a.Id" );
			ArrayList<InventoryItem> items = new ArrayList<InventoryItem>();
			while( result.next() ) {
				if( result.getInt("IsBodyPart") == 0 ) {
					items.add(new InventoryItem(result.getInt("Id"), 0, 0, result.getString("PublishDate"), result.getInt("MRId"), result.getInt("TRId"), 0, 0, 0, 0, 0));
				} else {
					items.add(new InventoryItem(result.getInt("Id"), 0, 0, result.getString("PublishDate"), result.getInt("MRId"), result.getInt("TRId"), 0, result.getInt("Id"), 1, result.getInt("Color"), 1));
				}
			}
			return items;
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return new ArrayList<InventoryItem>();
	}
	
	public static String getHousesFromInventory( int UID ) {
		String str = "";
		try {
			ResultSet rs = execute("SELECT * FROM goods WHERE `Id` IN (SELECT GoodId FROM houseinventory WHERE UserId = '"+UID+"')");
			while( rs.next() ) {
				str += "<item ID=\""+rs.getString("Id")+"\" MediaResourceID=\""+rs.getString("MRId")+"\" IsHome=\"1\" IsCurrent=\"0\" IsLocked=\"0\" />";
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return str;
	}
	
	public static String getFurnitureFromInventory( int UID ) {
		String str = "";
		try {
			ResultSet rs = execute("SELECT * FROM `goods` WHERE `Id` IN (SELECT GoodId FROM furnitureinventory WHERE UserId = '"+UID+"')");
			while( rs.next() ) {
				str += "<group ID=\"1$"+rs.getString("Id")+"\" AObjectTypeId=\"1\" AObjectId=\""+rs.getString("Id")+"\" AObjectRefTypeId=\""+rs.getString("GoodTypeId")+"\" MediaResourceID=\""+rs.getString("MRId")+"\" TextResourceID=\""+rs.getString("TRId")+"\"><object ID=\""+(rs.getInt("TRId")*2)+"\" IsActive=\"0\" /></group>";
			}
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return str;
	}
	
	public static void addPlayerCloth( int UID, String goodId ) {
		try {
			executeUpdate("INSERT INTO avatarinventory (UserId, GoodId) VALUES ('"+UID+"', '"+goodId+"')");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static void addPlayerFurniture( int UID, String goodId ) {
		try {
			executeUpdate("INSERT INTO furnitureinventory (UserId, GoodId) VALUES ('"+UID+"', '"+goodId+"')");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static void addPlayerHome( int UID, String goodId ) {
		try {
			executeUpdate("INSERT INTO houseinventory (UserId, GoodId) VALUES ('"+UID+"', '"+goodId+"')");
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	public static Catalog getCatalogById(String catalog ) {
		try {
			ResultSet result = execute( "SELECT CatalogTypeId, MediaResourceId FROM catalogs WHERE ID = '"+catalog+"'" );
			result.next();
			Catalog r = new Catalog( result.getInt("CatalogTypeId"), result.getInt("MediaResourceId"), new ArrayList<CatalogItem>() );
			result.close();
			result = execute( "SELECT * FROM catalogitems WHERE CId = '"+catalog+"'" );
			while( result.next() ) {
				r.getItems().add(new CatalogItem(result.getInt("ID"), result.getInt("TId"), result.getInt("UsualTickets"), result.getInt("MagicTickets") ));
			}
			return r;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}

	public static Good getGoodById(int goodId ) {
		try {
			ResultSet result = execute( "SELECT * FROM goods WHERE Id = '"+goodId+"'" );
			result.next();
			Good r = new Good( result.getInt("Id"), result.getInt("TRId"), result.getInt("MRId"), result.getInt("GoodTypeId"), result.getInt("RoleFlags"), result.getInt("UsualTickets"), result.getInt("MagicTickets"), result.getInt("LayerId"), result.getInt("IsActive") );
			return r;
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String md5( String str ) {
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			byte[] arr = md.digest(str.getBytes("UTF-8"));
			return Util.bytesToHex(arr);
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		return "";
	}
}